/* Evlan Client - Command shell for the Evlan programming language.
 * Copyright (C) 2004-2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

import java.awt.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.*;
import java.io.*;

public class Terminal implements Runnable, WindowListener
{
   public static void main(String[] parameters)
   {
      Terminal terminal = new Terminal();
   }

   Gui mGui;
   JFrame mFrame;

   public Terminal()
   {
      javax.swing.SwingUtilities.invokeLater(this);
   }

   public void run()
   {
      mFrame = new JFrame("Evlan Terminal");
      mGui = new Gui(false);
      mFrame.getContentPane().add(mGui);
      mFrame.addWindowListener(this);
      mFrame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
      mFrame.setSize(640, 400);
      mFrame.setVisible(true);

      mGui.start("localhost", 51310, true);
   }

   public void windowClosing(WindowEvent e)
   {
      try{mGui.stop();} catch(Throwable t) {}
      mFrame.dispose();
   }

   public void windowActivated  (WindowEvent e) {}
   public void windowClosed     (WindowEvent e) {}
   public void windowDeactivated(WindowEvent e) {}
   public void windowDeiconified(WindowEvent e) {}
   public void windowIconified  (WindowEvent e) {}
   public void windowOpened     (WindowEvent e) {}
}
