/* Evlan Client - Command shell for the Evlan programming language.
 * Copyright (C) 2004-2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

import java.awt.*;
import javax.swing.*;

public class TerminalApplet extends JApplet
{
   Gui mGui;

   // Applet =========================================================
   public void init()
   {
      String host = getParameter("host");
      if(host == null)
         host = getDocumentBase().getHost();
      if(host == null)
         host = "localhost";

      String portString = getParameter("port");
      int port = 51310;
      if(portString != null)
         try {port = Integer.parseInt(portString);} catch(Exception e) {}

      String useSsl = getParameter("use-ssl");

      mGui = new Gui(true);
      getContentPane().add(mGui);
      mGui.start(host, port, useSsl == null || !useSsl.equals("false"));
   }

   public void destroy()
   {
      mGui.stop();
   }
}
