/* Evlan - the Evlan programming language.
 * Copyright (C) 2002-2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/* Revision History:
 * 2004/05/05 (KV)
 *  + First Version
 */

// ===================================================================

#ifndef evlan_api_win32_file_h__INCLUDED__
#define evlan_api_win32_file_h__INCLUDED__

#include <framework/System.h>
#include <evlan/vm/native.h>

namespace evlan {
namespace api {
namespace win32 {
using namespace ::framework::common;
using framework::messages::EventManagerPtr;

// ===================================================================
// AUTHOR (KV): Created module.
// TODO (KV): Document evlan::api::win32::file
// TODO (KV): Test evlan::api::win32::file

namespace file
{
   unsigned long make(String path, bool create, framework::SystemPtr system);

   //my special error code!
   const unsigned long ERROR_IS_DIRECTORY = 0x40000000;
};

// ===================================================================

} //namespace win32
} //namespace api
} //namespace evlan

#endif //included
