/* Evlan - the Evlan programming language.
 * Copyright (C) 2002-2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

#ifndef evlan_compiler_ErrorCollector_h__INCLUDED
#define evlan_compiler_ErrorCollector_h__INCLUDED

// includes ==========================================================
#include <framework/common/all.h>

// begin namespace ===================================================
namespace evlan {
namespace compiler {
using namespace ::framework::common;

// class definition ==================================================
interface ErrorCollector;
typedef SmartPointer<ErrorCollector> ErrorCollectorPtr;

interface ErrorCollector: implements Object
{
   virtual ~ErrorCollector();

   virtual String setModule(String name) = 0;
   virtual int getErrorCount() = 0;

   virtual void addError  (int line, int column, String description) = 0;
   virtual void addError  (String description) = 0;
   virtual void addWarning(int line, int column, String description) = 0;
   virtual void addWarning(String description) = 0;
};

} //namespace compiler
} //namespace evlan

#endif //included
