/* Evlan - the Evlan programming language.
 * Copyright (C) 2002-2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/* Revision History:
 * 2004/04/01 (KV)
 *  + First Version
 */

// ===================================================================

#ifndef evlan_vm_arrays_h__INCLUDED__
#define evlan_vm_arrays_h__INCLUDED__

#include "core.h"

namespace evlan {
namespace vm {
using namespace ::framework::common;

// ===================================================================
// AUTHOR (KV): Created module.
// TODO (KV): Document evlan::vm::arrays
// TODO (KV): Test evlan::vm::arrays

namespace arrays
{
   void getElement(int index);
   void getElement();

   void tryPackArray();

   void repackData(void* target, const uint32* source, int size, int elementSize);

   void makeString(char* string);
   void makeString(char* string, int length);
   void makeString(String string);

   void copyString(char* buffer, core::Value value, bool nullTerminate = true);
   String getString(core::Value value);
   char* getCString(core::Value value);              //free with delete []

   inline int getStringLength(core::Value value)
   {
      if(value.isPackedArray()
      && value.packedArray.packType == core::Value::PACKED_CHARACTER)
         return value.packedArray.size;
      else
         return 0;
   }

   #define EV_MAKE_CSTRING(CSTRING_NAME, VALUE)                         \
      char CSTRING_NAME[::evlan::vm::arrays::getStringLength(VALUE)+1]; \
      ::evlan::vm::arrays::copyString(CSTRING_NAME, VALUE);
}

// ===================================================================

} //namespace vm
} //namespace evlan

#endif //included
