/* Evlan - the Evlan programming language.
 * Copyright (C) 2002-2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/* Revision History:
 * 2004/09/01 (KV)
 *  + First Version
 */

// ===================================================================

#ifndef evlan_vm_init_h__INCLUDED__
#define evlan_vm_init_h__INCLUDED__

#include <framework/System.h>
#include <evlan/compiler/ErrorCollector.h>

namespace evlan {
namespace vm {
using namespace ::framework::common;

// ===================================================================
// AUTHOR (KV): Created module.
// TODO (KV): Document evlan::vm::init
// TODO (KV): Test evlan::vm::init

namespace init
{
   void init(framework::SystemPtr system,
             String stateDirectory,
             String moduleDirectory,
             compiler::ErrorCollectorPtr errorCollector);

   void restore(framework::SystemPtr system,
                String stateDirectory, String moduleDirectory,
                compiler::ErrorCollectorPtr errorCollector,
                String stateName, int frame);

   void shutdown();
};

// ===================================================================

} //namespace vm
} //namespace evlan

#endif //included
