/* Evlan - the Evlan programming language.
 * Copyright (C) 2002-2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/* Revision History:
 * 2004/06/28 (KV)
 *  + First Version
 */

// ===================================================================

#include "memoryInternal.h"

namespace evlan {
namespace vm {

// ===================================================================
// AUTHOR (KV): Created module.
// TODO (KV): Implement evlan::vm::memoryInternal
// TODO (KV): Review evlan::vm::memoryInternal

namespace memory
{
   namespace sequence
   {
      uint64 counter = 0;
      int max = 0;
   }

   /* You'll need quite an uptime to have more than 64 generations.  I
    * don't think even FreeBSD has broken a million years yet. */
   Generation gGenerations[64];
   std::map<BlockKey, Block*> gBlockMap;
   std::map<BlockKey, InternalModule*> gModuleBlockMap;
#ifdef TRACK_DEADBLOCKS
   std::map<BlockKey, Block*> gDeadBlockMap;
#endif
   /* The heap now grows upwards!  It used to grow downwards.  There
    * is really no reason for me to tell you about this change since
    * this code has still never left my computer and thus no one else
    * is actually aware of which direction the Evlan heap grows, and
    * I myself certainly am not going to forget, but for some reason
    * I'm typing this anyway.  ...  I'm going to code that way now
    * ::points::... */
   word* gHeapTop = null;
   word* gHeapEnd = null;

#ifdef INCLUDE_WRITER_CODE
   TextWriterPtr gDebugOutput = null;
   int gDebugVerbosity = -1;
#endif //INCLUDE_WRITER_CODE

   Parameters gParameters;


   int Block::getFileLocation(word* pointer)
   {
      int index = pointer - data;
      int start = 0, end = fileSegmentCount;

      while(end - start > 1)
      {
         int midpoint = (start + end) / 2;

         if(fileSegments[midpoint].start > index)
            end = midpoint;
         else
            start = midpoint;
      }

      return (index - fileSegments[start].start) * sizeof(word)
           + fileSegments[start].fileLocation;
   }
}

// ===================================================================

} //namespace vm
} //namespace evlan
