/* Kenton Varda's C++ framework code.
 * Copyright (C) 2002-2005 Kenton Varda
 * <temporal@gauge3d.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/* Revision History:
 * 2004/04/15 (KV)
 *  + First Version
 */

// ===================================================================

#ifndef framework_TextWriter_h__INCLUDED__
#define framework_TextWriter_h__INCLUDED__

#include <framework/common/all.h>

namespace framework {
using namespace ::framework::common;

// ===================================================================
// AUTHOR (KV): Created module.
// TODO (KV): Document framework::TextWriter
// TODO (KV): Test framework::TextWriter

interface TextWriter;
typedef SmartPointer<TextWriter> TextWriterPtr;

interface TextWriter: implements Object
{
   virtual ~TextWriter();

   virtual void write(String text) = 0;
   virtual void write(char c, int count) = 0;

   virtual void flush() = 0;
   virtual void close() = 0;
};

// ===================================================================

} //namespace framework

#endif //included
