/* Kenton Varda's C++ framework code.
 * Copyright (C) 2002-2005 Kenton Varda
 * <temporal@gauge3d.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/* Revision History:
 * 2004/04/11 (KV)
 *  + First Version
 */

// ===================================================================

#ifndef framework_internal_MessageImpl_h__INCLUDED__
#define framework_internal_MessageImpl_h__INCLUDED__

#include <framework/messages/Message.h>

namespace framework {
namespace internal {
using namespace ::framework::common;

// ===================================================================
// AUTHOR (KV): Created module.
// TODO (KV): Document framework::internal::MessageQueue
// TODO (KV): Test framework::internal::MessageQueue

/* Creates an implementation of Message with the given receiver.  The
 * id and data arguments will be returned by the Message's
 * getIdentifier() and getData() methods, respectively.  Note that
 * this function should only be called by the receiver itself.  So,
 * the first argument should always be "this". */
messages::MessagePtr makeMessageImpl(messages::MessageReceiver* receiver,
                                     int id, ObjectPtr data);

/* Runs the message queue.  Messages will be popped from the top of
 * the queue and dispatched until either the queue is empty or the
 * given number of messages have been dispatched.  Returns the total
 * number of messages dispatched.  If messageCount is -1 (the
 * default), the loop will run until the queue is empty.
 *
 * Generally, you should not call this directly. */
int pumpMessageQueue(int messageCount = -1);

// ===================================================================

} //namespace internal
} //namespace framework

#endif //included
