/* Kenton Varda's C++ framework code.
 * Copyright (C) 2002-2005 Kenton Varda
 * <temporal@gauge3d.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/* Revision History:
 * 2003/04/11 (KV)
 *  + Imported code from Evlan.
 */

// ===================================================================

#include "Atom.h"
#include <vector>

namespace framework {
namespace util {

namespace  //anonymous (file-scope) namespace
{
   std::vector<String> gNames;
}

// class members =====================================================
Atom Atom::newAtom(String name)
{
   gNames.push_back(name);
   return Atom(gNames.size());
}

String Atom::getName()
{
   if(mIndex == 0)
      return $("null");
   else
      return gNames[mIndex - 1];
}

} //namespace util
} //namespace framework
