/* Io Chat - Chat applet for Io Community Manager.
 * Copyright (C) 2005 Kenton Varda
 * <http://www.evlan.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

import java.util.Properties;

class Command
{
   String name;
   Properties parameters;
   String text;

   public Command(String name, String text)
   {
      this.name = name;
      parameters = new Properties();
      this.text = text;
   }
   public Command(String command)
   {
      int firstColon = command.indexOf(':');
      Properties parameters = new Properties();
      String text = null;

      if(firstColon == -1)
         name = command;
      else
      {
         name = command.substring(0, firstColon);

         int pos = firstColon + 1;
         while(pos < command.length())
         {
            int next = command.indexOf(':', pos);
            if(next == pos)
            {
               //two colons: rest is the text
               text = command.substring(next + 1);
               break;
            }

            if(next == -1)
               next = command.length();

            int equals = command.indexOf('=', pos);
            if(equals == -1 || equals >= next)
               parameters.put(command.substring(pos, next), null);
            else
               parameters.put(command.substring(pos, equals), command.substring(equals+1, next));

            pos = next + 1;
         }
      }

      this.parameters = parameters;
      this.text = text;
   }
}
