@echo off

echo Note:  Some parts of kake take an extremely long time
echo        to compile.  Please be patient.

mkdir build
mkdir include
mkdir include\kake
echo Compiling Platform...
copy src\kake\Platform.h.win32 src\kake\Platform.h
copy src\kake\Platform.h include\kake
echo Compiling Filesystem...
c++ -O2 -Wall -c src/kake/Filesystem.cpp   -o build/kake_Filesystem.o   || goto ERROR
echo Compiling Process...
c++ -O2 -Wall -c src/kake/Process.cpp      -o build/kake_Process.o      || goto ERROR
echo Compiling Preprocessor...
c++ -O2 -Wall -c src/kake/Preprocessor.cpp -o build/kake_Preprocessor.o || goto ERROR
echo Compiling Compiler...
c++ -O2 -Wall -c src/kake/Compiler.cpp     -o build/kake_Compiler.o     || goto ERROR
echo Compiling Buildable...
c++ -O2 -Wall -c src/kake/Buildable.cpp    -o build/kake_Buildable.o    || goto ERROR
echo Compiling Module...
c++ -O2 -Wall -c src/kake/Module.cpp       -o build/kake_Module.o       || goto ERROR
echo Compiling Package...
c++ -O2 -Wall -c src/kake/Package.cpp      -o build/kake_Package.o      || goto ERROR
echo Compiling Binary...
c++ -O2 -Wall -c src/kake/Binary.cpp       -o build/kake_Binary.o       || goto ERROR
echo Compiling ParseElement...
c++ -O2 -Wall -c src/kake/ParseElement.cpp -o build/kake_ParseElement.o || goto ERROR
echo Compiling Parser...
c++ -O2 -Wall -c src/kake/Parser.cpp       -o build/kake_Parser.o       || goto ERROR
echo Compiling BuildfileElement...
c++ -O2 -Wall -c src/kake/BuildfileElement.cpp -o build/kake_BuildfileElement.o || goto ERROR
echo Compiling Kake...
c++ -O2 -Wall -c src/kake/Kake.cpp         -o build/kake_Kake.o         || goto ERROR

mkdir bin
echo Linking kake...
c++ -O2 -o bin/kake build/kake_*.o || goto ERROR

echo Build Succeeded...
goto END

:ERROR
echo Build Failed...

:END
pause
