/* kake - A Semi-Replacement for Make
 * Copyright (C) 2001 Kenton Varda
 * <temporal@gauge3d.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

#ifndef kake_Kake_H__INCLUDED__
#define kake_Kake_H__INCLUDED__

// includes ==========================================================
#include "Common.h"
#include <string>
#include "BuildfileElement.h"

namespace kake {
using namespace std;

// class definition ==================================================
class Kake
{
public:
   static int Main(int argc, char* argv[]);
   static void PrintUsage(string message);

   static bool Build(bool log);
   static bool Clean(BuildfileElement::CleanLevel level);
   static bool MakeInstallScript();
   static bool MakeSourceDistribution();
   static bool MakeBinaryDistribution();

private:
   static BuildfileElement* mBuildfile;
   static vector<string > mCommandParams;
};

} //namespace kake

#define KAKE_WRITE_MAIN(PACKAGE, MODULE)           \
   int main(int argc, char* argv[])                \
   {                                               \
      return PACKAGE::MODULE::Main(argc, argv);    \
   }

#endif //included
