/* kake - A Semi-Replacement for Make
 * Copyright (C) 2001 Kenton Varda
 * <temporal@gauge3d.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

#ifndef kake_Process_H__INCLUDED__
#define kake_Process_H__INCLUDED__

// includes ==========================================================
#include "Common.h"
#include <string>
#include <vector>

namespace kake {
using namespace std;

// class definition ==================================================
class Process
{
public:
   Process();
   ~Process();

   void Run(string progname, const vector<string >& params, bool usePipe);
   int Read(void* buf, int size);
   int Write(const void* buf, int size);
   void CloseOutput();
   int Wait();

   inline bool IsRunning() {return mChildPID != -1;}

   inline static void SetEcho(bool value) { mEcho = value; }

   static bool Test();

private:
   int mReadHandle;
   int mWriteHandle;
   int mChildPID;

   static bool mEcho;

   //disable copy
   Process(const Process& other);
   void operator=(const Process& other);
};

} //namespace kake

#endif //included
